<?php
if (!function_exists("gooyapay_redirect"))
{
	function gooyapay_redirect($url)
	{
		@header('Location: '. $url);
		echo "<meta http-equiv='refresh' content='0; url={$url}' />";
	}
}

if (!function_exists("gooyapay_encrypt_decrypt"))
{
	function gooyapay_encrypt_decrypt($action, $string)
	{
		$output 		= false;
		$encrypt_method = "AES-256-CBC";
		$secret_key 	= md5("659CE70DA471E");
		$secret_iv 		= md5($secret_key);
		$key 			= hash('sha256', $secret_key);
		$iv 			= substr(hash('sha256', $secret_iv), 0, 16);

		if ( $action == 'encrypt' )
		{
			$output = openssl_encrypt($string, $encrypt_method, $key, 0, $iv);
			$output = base64_encode($output);
		} else if( $action == 'decrypt' ) {
			$output = openssl_decrypt(base64_decode($string), $encrypt_method, $key, 0, $iv);
		}

		return $output;
	}
}

$MerchantID 	= (isset($_POST['merchantID']) && $_POST['merchantID'] != "") 	? $_POST['merchantID'] 		: false;
$InvoiceID 		= (isset($_POST['invoiceid']) && $_POST['invoiceid'] != "") 	? $_POST['invoiceid'] 		: 0;
$Email 			= (isset($_POST['Email']) && $_POST['Email'] != "") 			? $_POST['Email'] 			: "";
$Mobile 		= (isset($_POST['Mobile']) && $_POST['Mobile'] != "") 			? $_POST['Mobile'] 			: "";
$Amount 		= (isset($_POST['amount']) && $_POST['amount'] != "") 			? intval($_POST['amount']) 	: 0;
$Description 	= "Payment ID {$InvoiceID}";

if($_POST['currencies'] == 'Rial')
{
	$Amount = round($Amount / 10);
}

$ReturnData 	= gooyapay_encrypt_decrypt("encrypt", "{$InvoiceID}|{$Amount}");

$CallbackURL 	= (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://{$_SERVER['HTTP_HOST']}{$_SERVER['REQUEST_URI']}";
$CallbackURL 	= str_replace("\\", "/", $CallbackURL);
$CallbackURL 	= substr($CallbackURL, 0, strpos($CallbackURL, basename(__FILE__)));
$CallbackURL 	= rtrim($CallbackURL, "/");
$CallbackURL 	= "{$CallbackURL}/modules/gateways/callback/gooyapay.php?return={$ReturnData}";

$curl = curl_init();
curl_setopt($curl, CURLOPT_URL, 'https://gooyapay.ir/webservice/rest/PaymentRequest');
curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type' => 'application/json'));
curl_setopt($curl, CURLOPT_POSTFIELDS, "MerchantID={$MerchantID}&Amount={$Amount}&InvoiceID={$InvoiceID}&Description={$Description}&Email={$Email}&Mobile={$Mobile}&CallbackURL=". urlencode($CallbackURL));
curl_setopt($curl, CURLOPT_TIMEOUT, 30);
curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
$curl_exec = curl_exec($curl);
curl_close($curl);

$result = json_decode($curl_exec);

if (isset($result->Status) && $result->Status == 100)
{
	gooyapay_redirect($result->PaymentUrl);
	@header("Location: {$result->PaymentUrl}");
} else {
	echo (isset($result->Status) && $result->Status != "") ? $result->Status : "Error connecting to web service";
}
?>